// FileSaver.js:

(function(a,b){if("function"==typeof define&&define.amd)define([],b);else if("undefined"!=typeof exports)b();else{b(),a.FileSaver={exports:{}}.exports}})(this,function(){"use strict";function b(a,b){return"undefined"==typeof b?b={autoBom:!1}:"object"!=typeof b&&(console.warn("Deprecated: Expected third argument to be a object"),b={autoBom:!b}),b.autoBom&&/^\s*(?:text\/\S*|application\/xml|\S*\/\S*\+xml)\s*;.*charset\s*=\s*utf-8/i.test(a.type)?new Blob(["\uFEFF",a],{type:a.type}):a}function c(a,b,c){var d=new XMLHttpRequest;d.open("GET",a),d.responseType="blob",d.onload=function(){g(d.response,b,c)},d.onerror=function(){console.error("could not download file")},d.send()}function d(a){var b=new XMLHttpRequest;b.open("HEAD",a,!1);try{b.send()}catch(a){}return 200<=b.status&&299>=b.status}function e(a){try{a.dispatchEvent(new MouseEvent("click"))}catch(c){var b=document.createEvent("MouseEvents");b.initMouseEvent("click",!0,!0,window,0,0,0,80,20,!1,!1,!1,!1,0,null),a.dispatchEvent(b)}}var f="object"==typeof window&&window.window===window?window:"object"==typeof self&&self.self===self?self:"object"==typeof global&&global.global===global?global:void 0,a=/Macintosh/.test(navigator.userAgent)&&/AppleWebKit/.test(navigator.userAgent)&&!/Safari/.test(navigator.userAgent),g=f.saveAs||("object"!=typeof window||window!==f?function(){}:"download"in HTMLAnchorElement.prototype&&!a?function(b,g,h){var i=f.URL||f.webkitURL,j=document.createElement("a");g=g||b.name||"download",j.download=g,j.rel="noopener","string"==typeof b?(j.href=b,j.origin===location.origin?e(j):d(j.href)?c(b,g,h):e(j,j.target="_blank")):(j.href=i.createObjectURL(b),setTimeout(function(){i.revokeObjectURL(j.href)},4E4),setTimeout(function(){e(j)},0))}:"msSaveOrOpenBlob"in navigator?function(f,g,h){if(g=g||f.name||"download","string"!=typeof f)navigator.msSaveOrOpenBlob(b(f,h),g);else if(d(f))c(f,g,h);else{var i=document.createElement("a");i.href=f,i.target="_blank",setTimeout(function(){e(i)})}}:function(b,d,e,g){if(g=g||open("","_blank"),g&&(g.document.title=g.document.body.innerText="downloading..."),"string"==typeof b)return c(b,d,e);var h="application/octet-stream"===b.type,i=/constructor/i.test(f.HTMLElement)||f.safari,j=/CriOS\/[\d]+/.test(navigator.userAgent);if((j||h&&i||a)&&"undefined"!=typeof FileReader){var k=new FileReader;k.onloadend=function(){var a=k.result;a=j?a:a.replace(/^data:[^;]*;/,"data:attachment/file;"),g?g.location.href=a:location=a,g=null},k.readAsDataURL(b)}else{var l=f.URL||f.webkitURL,m=l.createObjectURL(b);g?g.location=m:location.href=m,g=null,setTimeout(function(){l.revokeObjectURL(m)},4E4)}});f.saveAs=g.saveAs=g,"undefined"!=typeof module&&(module.exports=g)});










// Generator:

function gen() {
	var check = true;
	var num  = parseInt(document.getElementById('num').value), sclr = starcolors;

	if (sclr.length <= 0) {
		alert("Error: No star colors found in Config.js!");
		check = false;
	}
	if (typeof num != "number") { // Num must be a number
		alert("Error: Invalid sprites number!");
		check = false;
	}
	if (typeof num == "number" && num < 1) { // A model with 0 sprites or even lower is invalid
		alert("Error: Sprites number is too low! Must be 1 or higher!");
		check = false;
	}
	if (typeof num == "number" && num > 1000000) { // Avoid the file getting heavy
		alert("Error: Sprites number is too high! Must be 1000000 or lower!");
		check = false;
	}
	if (check === true && typeof num == "number" && num >= 1 && num <= 1000000) { // Executes only when num >= 1 and num <= 1000000
		var out = document.getElementById('out');
		var tex = String(document.getElementById('tex').value);
		var ps1 = parseFloat(document.getElementById('ps1').value);
		var ps2 = parseFloat(document.getElementById('ps2').value);

		var cmod_1 = `#celmodel__ascii\n\nmaterial\nopacity 1\ntexture0 "${tex}"\nblend add\nend_material\n\n`;
		var cmod_2 = "mesh vertexdesc position f3 pointsize f1 color0 f3 end_vertexdesc\n\n";
		var cmod_3 = "vertices " + num + "\n";
		var cmod_4 = "";
		loop1: for (let i = 0; i < num; i++) { // Generate Vertices part of CMOD
			if (i >= num) {
				break loop1;
			} else {
				var min = -1;
				var max = 1;
				let rx = Math.random() * (max - min) + min;;
				let ry = Math.random() * (max - min) + min;;
				let rz = Math.random() * (max - min) + min;;
				let rp = Math.random() * (ps2 - ps1) + ps1;;
				let rs = Math.floor(Math.random() * sclr.length);
				let rc = sclr[rs];
				cmod_4 += "" + rx + " " + ry + " " + rz + " " + rp + " " + rc + "\n";
			}
		}
		var cmod_5 = "\nsprites 0 " + num + "\n";
		var cmod_6 = "";
		loop2: for (let j = 0; j < num; j++) {
			if (j >= num) {
				break loop2;
			} else {
				cmod_6 += "" + j + " ";
			}
		}
		var cmod_7 = "\n\nend_mesh";
		var cmod = String(cmod_1+cmod_2+cmod_3+cmod_4+cmod_5+cmod_6+cmod_7);
		if (showOutput === true) {
			out.innerText = cmod;
		}
		cel = String(cmod);
		if (saveFile === true) {
			var file = new Blob([cel], {type: "text/plain;charset=utf-8"});
			saveAs(file, "MySpritesModel.cmod");
		}
		if (showOutput === false && saveFile === false) {
			out.innerHTML = "<span style='color: red; padding: 5px; border: 1px solid red;'>Config.js: No output is true!</span>";
		}
	}

// ||
}
