
const starcolors = [ // create new variable. *DO NOT* change this line!

	// Define a list of possible star colors (in "R G B" format).
	// Adding a color multiple times increases the likelihood that that color will be used.

	// M (red) stars
	"1.0 0.0 0.0",
	"1.0 0.0 0.0",
	"1.0 0.1 0.0",
	"1.0 0.2 0.0",
	"1.0 0.3 0.0",

	// K (orange) stars
	"1.0 0.4 0.0",
	"1.0 0.5 0.0",
	"1.0 0.6 0.0",
	"1.0 0.7 0.0",

	// G (yellow) stars
	"1.0 0.8 0.0",
	"1.0 0.9 0.0",
	"1.0 1.0 0.0",
	"1.0 1.0 0.1",
	"1.0 1.0 0.2",

	// F (yellow-white) stars
	"1.0 1.0 0.3",
	"1.0 1.0 0.4",
	"1.0 1.0 0.5",
	"1.0 1.0 0.6",
	"1.0 1.0 0.7",
	"1.0 1.0 0.8",
	"1.0 1.0 0.9",
	"1.0 1.0 1.0",

	// A (blue-white) stars
	"1.0 1.0 1.0",
	"0.9 1.0 1.0",
	"0.8 1.0 1.0",
	"0.7 1.0 1.0",

	// B (light blue) stars
	"0.6 0.9 1.0",
	"0.5 0.8 1.0",
	"0.4 0.7 1.0",
	"0.3 0.6 1.0",
	"0.2 0.5 1.0",
	"0.1 0.4 1.0",
	"0.0 0.3 1.0",

	// O (blue) stars
	"0.0 0.2 1.0",
	"0.0 0.1 1.0",
	"0.0 0.0 1.0",

	// Custom star colors

	// To add own colors:
	//
	// Just add a new
	// "R G B",
	// (like above)
	// Possible values (for each color component (R, G, B)) are from 0 to 1
	//
	// DO NOT FORGET THE ',' (without ') after the string! It is required!
	// Only the last entry in this array *MUST NOT* have a ','!
	//
	// EXAMPLES:
	// Valid:
	//
	// "1.0 1.0 1.0",
	// "1.0 0.0 0.0",
	//
	// "1.0 0.9 1.0","1.0 0.0 0.0",
	// "1.0 0.9 1.0", "1.0 0.0 0.0",
	//
	// "1.0  1.0  1.0" // This will just make the .dsc file bigger (due to the spaces)
	//
	// Invalid:
	// "1.0 1.0 1.0"
	// "0.5 0.0 0.0"
	//
	// "1.01.01.0"  // Celestia error: multiple commas in one number
	// "1.01.01.0", // Celestia error: multiple commas in one number
	//
	// "1.0 0.9 1.0" "1.0 0.0 0.0" "1.0 1.0 1.0"




]; // close the array. DO NOT change this line!

const saveFile = true;   // Save file when generated  (either true or false), default is true
const showOutput = false; // Show output in html file (either true or false), default is false



